Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.pool
Class BaseKeyedObjectPool

    java.lang.Object
      org.apache.commons.pool.BaseKeyedObjectPool

All Implemented Interfaces:
  KeyedObjectPool

Direct Known Subclasses:
  GenericKeyedObjectPool, StackKeyedObjectPool

    public abstract class BaseKeyedObjectPool

extends Object
implements KeyedObjectPool

A simple base implementation of `KeyedObjectPool`. Optional operations are implemented to either do nothing, return a value indicating it is unsupported or throw `UnsupportedOperationException`.

Since:
  Pool 1.0
Version:
  $Revision: 1085933 $ $Date: 2011-03-27 06:40:20 -0700 (Sun, 27 Mar 2011) $
Author:
  Rodney Waldhoff, Sandy McArthur

Constructor Summary
`BaseKeyedObjectPool()`

Method Summary
`void` | `addObject(Object key)` Not supported in this base implementation.
`protected void` | `assertOpen()` Throws an `IllegalStateException` when this pool has been closed.
`abstract Object` | `borrowObject(Object key)` Obtains an instance from this pool for the specified `key`.
`void` | `clear()` Not supported in this base implementation.
`void` | `clear(Object key)` Not supported in this base implementation.
`void` | `close()` Close this pool.
`int` | `getNumActive()` Not supported in this base implementation.
`int` | `getNumActive(Object key)` Not supported in this base implementation.
`int` | `getNumIdle()` Not supported in this base implementation.
`int` | `getNumIdle(Object key)` Not supported in this base implementation.
`abstract void` | `invalidateObject(Object key, Object obj)` Invalidates an object from the pool.
`protected boolean` | `isClosed()` Has this pool instance been closed.
`abstract void` | `returnObject(Object key, Object obj)` Return an instance to the pool.
`void` | `setFactory(KeyedPoolableObjectFactory factory)` Deprecated. to be removed in pool 2.0

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### BaseKeyedObjectPool

    public BaseKeyedObjectPool()

Method Detail

### borrowObject

    public abstract Object borrowObject(Object key)
                                 throws Exception

  Obtains an instance from this pool for the specified `key`.

  Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then validated with `validateObject`.

  By contract, clients must return the borrowed object using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface, using a `key` that is `equivalent` to the one used to borrow the instance in the first place.

  The behaviour of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations). Older versions of this method would return `null` to indicate exhaustion, newer versions are encouraged to throw a `NoSuchElementException`.

  Specified by:
    `borrowObject` in interface `KeyedObjectPool`
  Parameters:
    `key` - the key used to obtain the object
  Returns:
    an instance from this pool.
  Throws:
    `IllegalStateException` - after `close` has been called on this pool
    `Exception` - when `makeObject` throws an exception
    `NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance

### returnObject

    public abstract void returnObject(Object key,
                                      Object obj)
                               throws Exception

  Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the instance in the first place.

  Specified by:
    `returnObject` in interface `KeyedObjectPool`
  Parameters:
    `key` - the key used to obtain the object
    `obj` - a `borrowed` instance to be returned.
  Throws:
    `Exception`

### invalidateObject

    public abstract void invalidateObject(Object key,
                                          Object obj)
                                   throws Exception

  Invalidates an object from the pool.

  By contract, `obj` must have been obtained using `borrowObject` using a `key` that is equivalent to the one used to borrow the `Object` in the first place.

  This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

  Specified by:
    `invalidateObject` in interface `KeyedObjectPool`
  Parameters:
    `key` - the key used to obtain the object
    `obj` - a `borrowed` instance to be returned.
  Throws:
    `Exception`

### addObject

    public void addObject(Object key)
                   throws Exception,
                          UnsupportedOperationException

  Not supported in this base implementation. Always throws an `UnsupportedOperationException`, subclasses should override this behavior.

  Specified by:
    `addObject` in interface `KeyedObjectPool`
  Parameters:
    `key` - ignored
  Throws:
    `UnsupportedOperationException`
    `Exception` - when `KeyedPoolableObjectFactory.makeObject(java.lang.Object)` fails.
    `IllegalStateException` - after `KeyedObjectPool.close()` has been called on this pool.

### getNumIdle

    public int getNumIdle(Object key)
                   throws UnsupportedOperationException

  Not supported in this base implementation.

  Specified by:
    `getNumIdle` in interface `KeyedObjectPool`
  Parameters:
    `key` - ignored
  Returns:
    a negative value.
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### getNumActive

    public int getNumActive(Object key)
                     throws UnsupportedOperationException

  Not supported in this base implementation.

  Specified by:
    `getNumActive` in interface `KeyedObjectPool`
  Parameters:
    `key` - ignored
  Returns:
    a negative value.
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### getNumIdle

    public int getNumIdle()
                   throws UnsupportedOperationException

  Not supported in this base implementation.

  Specified by:
    `getNumIdle` in interface `KeyedObjectPool`
  Returns:
    a negative value.
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### getNumActive

    public int getNumActive()
                     throws UnsupportedOperationException

  Not supported in this base implementation.

  Specified by:
    `getNumActive` in interface `KeyedObjectPool`
  Returns:
    a negative value.
  Throws:
    `UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

### clear

    public void clear()
               throws Exception,
                      UnsupportedOperationException

  Not supported in this base implementation.

  Specified by:
    `clear` in interface `KeyedObjectPool`
  Throws:
    `UnsupportedOperationException`
    `Exception`

### clear

    public void clear(Object key)
               throws Exception,
                      UnsupportedOperationException

  Not supported in this base implementation.

  Specified by:
    `clear` in interface `KeyedObjectPool`
  Parameters:
    `key` - ignored
  Throws:
    `UnsupportedOperationException`
    `Exception`

### close

    public void close()
               throws Exception

  Close this pool. This affects the behavior of `isClosed` and `assertOpen`.

  Specified by:
    `close` in interface `KeyedObjectPool`
  Throws:
    `Exception`

### setFactory

    public void setFactory(KeyedPoolableObjectFactory factory)
                    throws IllegalStateException,
                           UnsupportedOperationException

  Deprecated. to be removed in pool 2.0

  Not supported in this base implementation. Always throws an `UnsupportedOperationException`, subclasses should override this behavior.

  Specified by:
    `setFactory` in interface `KeyedObjectPool`
  Parameters:
    `factory` - the new KeyedPoolableObjectFactory
  Throws:
    `IllegalStateException` - when the factory cannot be set at this time
    `UnsupportedOperationException` - when this implementation doesn't support the operation

### isClosed

    protected final boolean isClosed()

  Has this pool instance been closed.

  Returns:
    `true` when this pool has been closed.
  Since:
    Pool 1.4

### assertOpen

    protected final void assertOpen()
                             throws IllegalStateException

  Throws an `IllegalStateException` when this pool has been closed.

  Throws:
    `IllegalStateException` - when this pool has been closed.
  Since:
    Pool 1.4
  See Also:
    `isClosed()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2011 The Apache Software Foundation. All Rights Reserved.